# coding: utf-8

"""
    Xero Finance API

    The Finance API is a collection of endpoints which customers can use in the course of a loan application, which may assist lenders to gain the confidence they need to provide capital.  # noqa: E501

    Contact: api@xero.com
    Generated by: https://openapi-generator.tech
"""


import re  # noqa: F401

from xero_python.models import BaseModel


class TrialBalanceMovement(BaseModel):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        "debits": "float",
        "credits": "float",
        "movement": "TrialBalanceEntry",
        "signed_movement": "float",
    }

    attribute_map = {
        "debits": "debits",
        "credits": "credits",
        "movement": "movement",
        "signed_movement": "signedMovement",
    }

    def __init__(
        self, debits=None, credits=None, movement=None, signed_movement=None
    ):  # noqa: E501
        """TrialBalanceMovement - a model defined in OpenAPI"""  # noqa: E501

        self._debits = None
        self._credits = None
        self._movement = None
        self._signed_movement = None
        self.discriminator = None

        if debits is not None:
            self.debits = debits
        if credits is not None:
            self.credits = credits
        if movement is not None:
            self.movement = movement
        if signed_movement is not None:
            self.signed_movement = signed_movement

    @property
    def debits(self):
        """Gets the debits of this TrialBalanceMovement.  # noqa: E501

        Debit amount  # noqa: E501

        :return: The debits of this TrialBalanceMovement.  # noqa: E501
        :rtype: float
        """
        return self._debits

    @debits.setter
    def debits(self, debits):
        """Sets the debits of this TrialBalanceMovement.

        Debit amount  # noqa: E501

        :param debits: The debits of this TrialBalanceMovement.  # noqa: E501
        :type: float
        """

        self._debits = debits

    @property
    def credits(self):
        """Gets the credits of this TrialBalanceMovement.  # noqa: E501

        Credit amount  # noqa: E501

        :return: The credits of this TrialBalanceMovement.  # noqa: E501
        :rtype: float
        """
        return self._credits

    @credits.setter
    def credits(self, credits):
        """Sets the credits of this TrialBalanceMovement.

        Credit amount  # noqa: E501

        :param credits: The credits of this TrialBalanceMovement.  # noqa: E501
        :type: float
        """

        self._credits = credits

    @property
    def movement(self):
        """Gets the movement of this TrialBalanceMovement.  # noqa: E501


        :return: The movement of this TrialBalanceMovement.  # noqa: E501
        :rtype: TrialBalanceEntry
        """
        return self._movement

    @movement.setter
    def movement(self, movement):
        """Sets the movement of this TrialBalanceMovement.


        :param movement: The movement of this TrialBalanceMovement.  # noqa: E501
        :type: TrialBalanceEntry
        """

        self._movement = movement

    @property
    def signed_movement(self):
        """Gets the signed_movement of this TrialBalanceMovement.  # noqa: E501

        Value of movement. Expense and Asset accounts code debits as positive. Revenue, Liability, and Equity accounts code debits as negative  # noqa: E501

        :return: The signed_movement of this TrialBalanceMovement.  # noqa: E501
        :rtype: float
        """
        return self._signed_movement

    @signed_movement.setter
    def signed_movement(self, signed_movement):
        """Sets the signed_movement of this TrialBalanceMovement.

        Value of movement. Expense and Asset accounts code debits as positive. Revenue, Liability, and Equity accounts code debits as negative  # noqa: E501

        :param signed_movement: The signed_movement of this TrialBalanceMovement.  # noqa: E501
        :type: float
        """

        self._signed_movement = signed_movement
